import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:osam/osam.dart';

import 'repository.dart';
import 'state.dart';
import 'usecase.dart';

void main() {
  final repoFactory = RepoFactory();

  final countRepository = repoFactory.counterRepo();

  final appState = AppState(Counter());

  final useCase = CounterUseCase(countRepository, appState);

  final useCaseContainer = UseCaseContainer([useCase]);

  runApp(UseCaseProvider(
    appState,
    useCaseContainer,
    null,
    child: MyApp(),
  ));
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Center(
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[],
        ),
      ),
    );
  }
}
